#include "stdafx.h"

// ϼ ڿ ѱ ڸ Ѵ. ߰    ȯѴ.
void BreakHangul(const char* in, char* out)
{
	int i, idx;
	wchar_t Han, Cho, Jung, Jong;
	char* pJohab;
	char* pTemp;
	int inlen, jolen;

	inlen = strlen(in);
	pJohab = (char*)calloc(inlen * 2 + 100, 1);
	pTemp = (char*)calloc(inlen * 4 + 100, 1);
	WansungToJohab(in, pJohab);
	jolen = (int)strlen(pJohab);
	for (i = 0, idx = 0; i < jolen; i++) {
		if (IsDBCSLeadByte(in[i])) {
			Han = MAKEWORD(pJohab[i + 1], pJohab[i]);
			Cho = GetChosung(Han, (Han & 0x7c00) >> 10);
			Jung = GetJungsung(Han, (Han & 0x03e0) >> 5);
			Jong = GetJongsung(Han, Han & 0x001f);

			if (Cho) {
				pTemp[idx++] = HIBYTE(Cho);
				pTemp[idx++] = LOBYTE(Cho);
			}
			if (Jung) {
				pTemp[idx++] = HIBYTE(Jung);
				pTemp[idx++] = LOBYTE(Jung);
			}
			if (Jong) {
				pTemp[idx++] = HIBYTE(Jong);
				pTemp[idx++] = LOBYTE(Jong);
			}
			i++;
		}
		else {
			pTemp[idx++] = in[i];
		}
	}
	pTemp[idx] = 0;
	JohabToWansung(pTemp, out);
	free(pTemp);
	free(pJohab);
}

//  ʼ ִ ڵ 
wchar_t GetChosung(wchar_t Han, int Cho)
{
	static wchar_t arCode[32] = { 0,0,0x8841,0x8c41,0x9041,0x9441,0x9841,0x9c41,
		0xa041,0xa441,0xa841,0xac41,0xb041,0xb441,0xb841,0xbc41,0xc041,0xc441,
		0xc841,0xcc41,0xd041,
	};

	return arCode[Cho];
}

//  ߼ ִ ڵ 
wchar_t GetJungsung(wchar_t Han, int Jung)
{
	static wchar_t arCode[32] = { 0,0,0,0x8461,0x8481,0x84a1,0x84c1,0x84e1,
		0,0,0x8541,0x8561,0x8581,0x85a1,0x85c1,0x85e1,0,0,0x8641,0x8661,
		0x8681,0x86a1,0x86c1,0x86e1,0,0,0x8741,0x8761,0x8781,0x87a1,
	};

	return arCode[Jung];
}

//   ִ ڵ 
wchar_t GetJongsung(wchar_t Han, int Jong)
{
	static wchar_t arCode[32] = { 0,0,0x8442,0x8443,0x8444,0x8445,0x8446,
		0x8447,0x8448,0x8449,0x844a,0x844b,0x844c,0x844d,0x844e,0x844f,
		0x8450,0x8451,0,0x8453,0x8454,0x8455,0x8456,0x8457,0x8458,
		0x8459,0x845a,0x845b,0x845c,0x845d,
	};

	return arCode[Jong];
}

// ϼ 
void WansungToJohab(const char* in, char* out)
{
	size_t len = strlen(in);
	wchar_t* pUni = (wchar_t*)calloc(len * 2 + 2, 1);

	MultiByteToWideChar(CP_WANSUNG, MB_ERR_INVALID_CHARS, in, -1, pUni, len * 2);
	WideCharToMultiByte(CP_JOHAB, 0, pUni, -1, out, len + 1, 0, 0);
	free(pUni);
}

//  ϼ
void JohabToWansung(const char* in, char* out)
{
	size_t len = strlen(in);
	wchar_t* pUni = (wchar_t*)calloc(len * 2 + 2, 1);

	MultiByteToWideChar(CP_JOHAB, MB_ERR_INVALID_CHARS, in, -1, pUni, len * 2);
	WideCharToMultiByte(CP_WANSUNG, 0, pUni, -1, out, len + 1, 0, 0);
	free(pUni);
}

//  ڵ ϳ  ҷ Ǿ ִ Ѵ.
int GetHanCount(wchar_t Han)
{
	static unsigned char arNum[3][32] = {
		{0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0},
		{0,0,0,1,1,1,1,1,0,0,1,1,1,1,2,2,0,0,2,1,1,2,2,2,0,0,1,1,2,1,0,0},
		{0,0,1,1,2,1,2,2,1,1,2,2,2,2,2,2,2,1,0,1,2,1,1,1,1,1,1,1,1,1,0,0}
	};

	return arNum[0][(Han & 0x7c00) >> 10] + arNum[1][(Han & 0x03e0) >> 5] +
		arNum[2][Han & 0x001f];
}

//  ڵ  ڿ Ҽ 
int GetHanStringCount(char* szHan)
{
	int Num = 0;
	int idx;
	char* pJohab;

	pJohab = (char*)calloc(strlen(szHan) + 1, 1);
	WansungToJohab(szHan, pJohab);
	for (idx = 0; pJohab[idx];) {
		if (pJohab[idx] & 0x80) {
			Num += GetHanCount(MAKEWORD(pJohab[idx + 1], pJohab[idx]));
			idx += 2;
		}
		else {
			Num++;
			idx += 1;
		}
	}
	free(pJohab);
	return Num;
}

//  ϰ  ġ INI  θ ʱȭѴ. 
void CSetting::SetIniPath(LPCTSTR filename)
{
	TCHAR* p;

	GetModuleFileName(NULL, iniPath, MAX_PATH);

	// ϸ  ʾ  ϸ Ȯڸ ini Ѵ. 
	if (filename == NULL) {
		p = _tcsrchr(iniPath, '.');
		*(p + 1) = 0;
		lstrcat(iniPath, TEXT("ini"));
	} else {
		p = _tcsrchr(iniPath, '\\');
		*(p + 1) = 0;
		lstrcat(iniPath, filename);
	}
}

int CSetting::get(strtype section, LPCTSTR key, int defValue)
{
	if (useIni) {
		return GetPrivateProfileInt(section.c_str(), key, defValue, iniPath);
	} else {
		TCHAR regPath[MAX_PATH];
		HKEY hKey;
		DWORD dwDisp;
		INT Result;
		DWORD cbSize;

		Result = defValue;
		lstrcpy(regPath, regRoot);
		lstrcat(regPath, section.c_str());
		if (RegCreateKeyEx(hive, regPath, 0, NULL, REG_OPTION_NON_VOLATILE,
			KEY_READ, NULL, &hKey, &dwDisp) == ERROR_SUCCESS) {
			if (dwDisp == REG_OPENED_EXISTING_KEY) {
				cbSize = sizeof(LONG);
				if (RegQueryValueEx(hKey, key, 0, NULL, (LPBYTE)&Result, &cbSize)
					!= ERROR_SUCCESS) {
					Result = defValue;
				}
			}
			RegCloseKey(hKey);
		}
		return Result;
	}
}

//  ũ 128 ̻ Ȯؾ Ѵ.  ̻ API Լ  ȣ 
void CSetting::get(strtype section, LPCTSTR key, LPCTSTR defValue, LPTSTR retValue, int nSize/* = 128*/)
{
	if (useIni) {
		GetPrivateProfileString(section.c_str(), key, defValue, retValue, nSize, iniPath);
	} else {
		TCHAR regPath[MAX_PATH];
		HKEY hKey;
		DWORD dwDisp;
		DWORD cbSize;
		bool Result = false;

		lstrcpy(regPath, regRoot);
		lstrcat(regPath, section.c_str());
		if (RegCreateKeyEx(hive, regPath, 0, NULL, REG_OPTION_NON_VOLATILE,
			KEY_READ, NULL, &hKey, &dwDisp) == ERROR_SUCCESS) {
			if (dwDisp == REG_OPENED_EXISTING_KEY) {
				cbSize = nSize * sizeof(TCHAR);
				if (RegQueryValueEx(hKey, key, 0, NULL, (LPBYTE)retValue, &cbSize)
					== ERROR_SUCCESS) {
					Result = true;
				}
			}
			RegCloseKey(hKey);
		}

		if (Result == false) {
			lstrcpy(retValue, defValue);
		}
	}
}

// Ǽ б - ڿ   Ǽ ȯϿ Ѵ. 
double CSetting::getDouble(strtype section, LPCTSTR key, double defValue)
{
	TCHAR buf[128];
	get(section, key, TEXT(""), buf);
	if (lstrlen(buf) == 0) {
		return defValue;
	} else {
		TCHAR* endptr;
		return _tcstod(buf, &endptr);
	}
}

bool CSetting::set(strtype section, LPCTSTR key, int value)
{
	if (useIni) {
		//  ڿ ٲ㼭 Ѵ.
		TCHAR buf[64];
		wsprintf(buf, TEXT("%d"), value);
		WritePrivateProfileString(section.c_str(), key, buf, iniPath);
		return true;
	} else {
		TCHAR regPath[MAX_PATH];
		HKEY hKey;
		DWORD dwDisp;
		bool Result = false;

		lstrcpy(regPath, regRoot);
		lstrcat(regPath, section.c_str());
		if (RegCreateKeyEx(hive, regPath, 0, NULL, REG_OPTION_NON_VOLATILE,
			KEY_WRITE, NULL, &hKey, &dwDisp) == ERROR_SUCCESS) {
			if (RegSetValueEx(hKey, key, 0, REG_DWORD, (LPBYTE)&value, sizeof(INT))
				== ERROR_SUCCESS) {
				Result = true;
			}
			RegCloseKey(hKey);
		}
		return Result;
	}
}

bool CSetting::set(strtype section, LPCTSTR key, LPCTSTR value)
{
	if (useIni) {
		WritePrivateProfileString(section.c_str(), key, value, iniPath);
		return true;
	} else {
		TCHAR regPath[MAX_PATH];
		HKEY hKey;
		DWORD dwDisp;
		bool Result = false;

		lstrcpy(regPath, regRoot);
		lstrcat(regPath, section.c_str());
		if (RegCreateKeyEx(hive, regPath, 0, NULL, REG_OPTION_NON_VOLATILE,
			KEY_WRITE, NULL, &hKey, &dwDisp) == ERROR_SUCCESS) {
			if (RegSetValueEx(hKey, key, 0, REG_SZ, (LPBYTE)value,
				(lstrlen(value) + 1) * sizeof(TCHAR)) == ERROR_SUCCESS) {
				Result = true;
			}
			RegCloseKey(hKey);
		}
		return Result;
	}
}

bool CSetting::setDouble(strtype section, LPCTSTR key, double value)
{
	TCHAR buf[128];
	_stprintf_s(buf, TEXT("%f"), value);
	return set(section, key, buf);
}

//  ü Ѵ.
void CSetting::deleteSection(strtype section)
{
	if (useIni) {
		// ι° μ NULL̸ section  Ѵ.
		WritePrivateProfileString(section.c_str(), NULL, NULL, iniPath);
	} else {
		// Ʈ   ̱
	}
}

void DrawBitmap(HDC hdc, int x, int y, HBITMAP hBit)
{
	HDC MemDC;
	HBITMAP OldBitmap;
	int bx, by;
	BITMAP bit;

	MemDC = CreateCompatibleDC(hdc);
	OldBitmap = (HBITMAP)SelectObject(MemDC, hBit);

	GetObject(hBit, sizeof(BITMAP), &bit);
	bx = bit.bmWidth;
	by = bit.bmHeight;

	BitBlt(hdc, x, y, bx, by, MemDC, 0, 0, SRCCOPY);

	SelectObject(MemDC, OldBitmap);
	DeleteDC(MemDC);
}

void TextOutFmt(HDC hdc, int x, int y, char* str, HFONT hFont/*=NULL*/, COLORREF Color/*=0*/, UINT Align/*=0*/)
{
	HFONT OldFont;
	UINT OldAlign;
	COLORREF OldColor;

	if (hFont) OldFont = (HFONT)SelectObject(hdc, hFont);
	if (Color) OldColor = SetTextColor(hdc, Color);
	if (Align) OldAlign = SetTextAlign(hdc, Align);

	TextOut(hdc, x, y, str, lstrlen(str));

	if (hFont) SelectObject(hdc, OldFont);
	if (Color) SetTextColor(hdc, OldColor);
	if (Align) SetTextAlign(hdc, OldAlign);
}

// IME 带 Ѵ. ѱ  TRUE 
//  μ  Ʈѿ ؼ  Ǹ ٸ μ Ʈ   ʴ´.
BOOL MyGetImeMode(HWND hEdit)
{
	HIMC hImc;
	DWORD Con, Sen;

	hImc = ImmGetContext(hEdit);
	ImmGetConversionStatus(hImc, &Con, &Sen);
	ImmReleaseContext(hEdit, hImc);
	if (Con & IME_CMODE_NATIVE) {
		return TRUE;
	} else {
		return FALSE;
	}
}

// IME 带 Ѵ. ٸ μ  ȵ
void MySetImeMode(HWND hEdit, BOOL bHan)
{
	HIMC hImc;
	hImc = ImmGetContext(hEdit);

	if (bHan == TRUE) {
		ImmSetConversionStatus(hImc, IME_CMODE_NATIVE, IME_SMODE_NONE);
	} else {
		ImmSetConversionStatus(hImc, 0, IME_SMODE_NONE);
	}

	ImmReleaseContext(hEdit, hImc);
}

void SwapWord(WORD* pWord)
{
	BYTE t;
	t = HIBYTE(*pWord);
	*pWord = (*pWord << 8 | t);
}

void SavePosition(HWND hWnd)
{
	WINDOWPLACEMENT wndpl;

	wndpl.length = sizeof(WINDOWPLACEMENT);
	GetWindowPlacement(hWnd, &wndpl);

	setting.set("Position", "showCmd", wndpl.showCmd);
	setting.set("Position", "left", wndpl.rcNormalPosition.left);
	setting.set("Position", "top", wndpl.rcNormalPosition.top);
	setting.set("Position", "right", wndpl.rcNormalPosition.right);
	setting.set("Position", "bottom", wndpl.rcNormalPosition.bottom);
}

void LoadPosition(HWND hWnd, RECT* Def/*=NULL*/)
{
	WINDOWPLACEMENT wndpl;
	RECT drt;

	if (Def == NULL) {
		SetRect(&drt, 10, 10, 1400, 800);
	} else {
		CopyRect(&drt, Def);
	}
	wndpl.length = sizeof(WINDOWPLACEMENT);
	wndpl.flags = 0;
	wndpl.rcNormalPosition.left = setting.get("Position", "left", drt.left);
	wndpl.rcNormalPosition.top = setting.get("Position", "top", drt.top);
	wndpl.rcNormalPosition.right = setting.get("Position", "right", drt.right);
	wndpl.rcNormalPosition.bottom = setting.get("Position", "bottom", drt.bottom);
	wndpl.showCmd = setting.get("Position", "showCmd", SW_SHOWNORMAL);
	
	if (wndpl.showCmd == SW_SHOWMINIMIZED) {
		wndpl.showCmd = SW_RESTORE;
	}
	
	wndpl.ptMinPosition.x = wndpl.ptMinPosition.y = 0;
	wndpl.ptMaxPosition.x = wndpl.ptMaxPosition.y = 0;
	SetWindowPlacement(hWnd, &wndpl);
}

#ifdef _DEBUG
void Trace(LPCTSTR format, ...)
{
	TCHAR buf[1024];
	va_list marker;

	va_start(marker, format);
	_vstprintf_s(buf, Count(buf), format, marker);
	lstrcat(buf, TEXT("\r\n"));
	OutputDebugString(buf);
}

void WriteLog(LPCTSTR strLog, ...)
{
	static int count = 0;
	static LPCTSTR LogPath = TEXT("c:\\Temp\\Sojett_Debug.txt");
	HANDLE hLog;
	DWORD dwWritten;
	TCHAR szLog[1024];
	TCHAR strLog2[1024];
	va_list marker;
	SYSTEMTIME st;

	va_start(marker, strLog);
	_vstprintf_s(szLog, Count(szLog), strLog, marker);

	if (count == 0) {
		hLog = CreateFile(LogPath, GENERIC_WRITE, 0, NULL,
			CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	} else {
		hLog = CreateFile(LogPath, GENERIC_WRITE, 0, NULL,
			OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	}

	GetLocalTime(&st);
	_stprintf_s(strLog2, Count(strLog2), TEXT("ī=%06d(%d:%d:%d:%d) %s\r\n"), count++,
		st.wHour, st.wMinute, st.wSecond, st.wMilliseconds, szLog);
	SetFilePointer(hLog, 0, NULL, FILE_END);
	WriteFile(hLog, strLog2, lstrlen(strLog2), &dwWritten, NULL);
	CloseHandle(hLog);
}
#else
void Trace(LPCTSTR format, ...) { ; }
void WriteLog(LPCTSTR strLog, ...) { ; }
#endif

// и  ȼ  ٲ۴. ܱ Ѵ.
// Ǽ    float Ÿ ޴´. 
int Mili2Pixel(float mili)
{
	return (int)(dpiX * mili / 25.4 * (Opt.k_zoom / 100.0f));
}

// Ǽ    ε
int Mili2Pixel(int mili)
{
	return Mili2Pixel((float)mili);
}

void MoveToParentCenter(HWND hWnd)
{
	RECT wrt, crt;
	HWND hParent;

	hParent = GetParent(hWnd);
	if (hParent == NULL) {
		return;
	}
	if (IsIconic(hParent)) {
		ShowWindow(hParent, SW_RESTORE);
	}

	GetWindowRect(hParent, &wrt);
	GetWindowRect(hWnd, &crt);
	SetWindowPos(hWnd, HWND_NOTOPMOST, wrt.left + (wrt.right - wrt.left) / 2 - (crt.right - crt.left) / 2,
		wrt.top + (wrt.bottom - wrt.top) / 2 - (crt.bottom - crt.top) / 2, 0, 0, SWP_NOSIZE);
}

// st ¥  ʸ Ѵ. 2000 1 1  
DWORD MyGetAbsSecond(SYSTEMTIME st)
{
	INT64 i64;
	FILETIME fst;

	SystemTimeToFileTime(&st, &fst);
	i64 = (((INT64)fst.dwHighDateTime) << 32) + fst.dwLowDateTime;
	// ʴ ȯϰ 2000 1 1   ٲ۴.
	i64 = i64 / 10000000 - (INT64)145731 * 86400;

	return (DWORD)i64;
}

// ʸ ý Ÿ ٲ۴.
void MyAbsSecondToSystem(DWORD Abs, SYSTEMTIME& st)
{
	INT64 i64;
	FILETIME fst;

	i64 = (Abs + (INT64)145731 * 86400) * 10000000;
	fst.dwHighDateTime = (DWORD)(i64 >> 32);
	fst.dwLowDateTime = (DWORD)(i64 & 0xffffffff);
	FileTimeToSystemTime(&fst, &st);
}